from math import*
from random import*

n=int(input("Donnez moi la taille de votre jeu"))
#position initial joueur 1 et 2
p=[(1+n)//2,(2*n**2-n+1)//2]  
#print(p)

#tableau mémorisant les murs
M=[]
for i in range(n**2):
    L=[]
    for i in range(n**2):
        L.append(0)
    M.append(L)

#conditions mvt     
def conditions(p_joueur,pos_possible):
    if p_joueur%n==1:    #si le pion est sur une colonne de gauche, on retire la case à gauche
        pos_possible[0]=0   #on met zéros pour ne pas perdre les rangs et que chacun ait sa place
    if p_joueur<=n:     #si le pion est sur la 1ère ligne, on retire la case à l'arrière
        pos_possible[2]=0
    if p_joueur%n==0:   #si le pion est sur une colonne de droite, on retire la case à droite
        pos_possible[1]=0
    if p_joueur<=n**2 and p[i]>n**2-n:     #si le pion est sur la dernière ligne, on retire la case devant
        pos_possible[3]=0
    return(pos_possible)  #retourne la liste mise à jour



#mouvement des joueurs
def mvt_p (i):
    pos_possible=[p[i]-1,p[i]+1,p[i]-n,p[i]+n]      #liste des cases adjacentes accessibles par défaut
    pos_possible=conditions(p[i],pos_possible)    #On lance le prog conditions pour retirer tous les nombres hors du damier 
    pos_possible1=[p[i]-2,p[i]+2,p[i]-n*2,p[i]+n*2]   #liste des cases si on saute le joueur adverse
    pos_possible_diag=[1,1,1,1]     #cas où on partirait en diagonale
    if p[(i+1)%2] in pos_possible :   #on vérifie s'il est collé à l'adversaire et on modifie la case d'accès si oui
        r=pos_possible.index(p[(i+1)%2])  # on récupère l'indice de la position du joueur adverse
        if r == 0:    #indique où est le joueur par rapport à l'autre 
            #print("Le joueur est à gauche de l'autre joueur")
            if p[i]%n>2:   #test pour savoir si on sort du plateau
                pos_possible[r]=pos_possible1[r]  #on remplace la case occupée par l'adverse et on met celle après le saut.
            else:
                del pos_possible[0]             #sinon on part en diagonale et on rajoute les possibilités qui ne sortent pas du plateau
                DP=conditions(p[(i+1)%2],pos_possible_diag)
                if DP[2]==1:
                    pos_possible.append(p[(i+1)%2]+n)
                if DP[3]==1:
                    pos_possible.append(p[(i+1)%2]-n) 
                             
        if r == 1:
            if p[i]%n!=n-1 and p[i]%n!=0:
                #print("Le joueur est à droite de l'autre joueur")
                pos_possible[r]=pos_possible1[r]  
            else:
                del pos_possible[1]
                DP=conditions(p[(i+1)%2],pos_possible_diag)
                if DP[2]==1:
                    pos_possible.append(p[(i+1)%2]+n)
                if DP[3]==1:
                    pos_possible.append(p[(i+1)%2]-n)
                
        if r == 2 :
            if p[i]>2*n:
                #print("Le joueur est devant l'autre joueur, case numéro plus petite")
                pos_possible[r]=pos_possible1[r]  
            else:
                del pos_possible[2]
                DP=conditions(p[(i+1)%2],pos_possible_diag)
                if DP[0]==1:
                    pos_possible.append(p[(i+1)%2]-1)
                if DP[1]==1:
                    pos_possible.append(p[(i+1)%2]+1)
                    
        if r == 3:
            if p[i]<=n**2-2*n:
                #print("Le joueur est derrière l'autre joueur, case numéro plus grand")
                pos_possible[r]=pos_possible1[r]  
            else:
                del pos_possible[3]
                DP=conditions(p[(i+1)%2],pos_possible_diag)
                if DP[0]==1:
                    pos_possible.append(p[(i+1)%2]-1)
                if DP[1]==1:
                    pos_possible.append(p[(i+1)%2]+1)
           
             

       
    while 0 in pos_possible:    #on retire les zéros mis par le programme conditions
        pos_possible.remove(0)  
    #print("les possibilités sont", pos_possible)
    #on a maintenant une liste prête à être utilisée
    if i == 0:
        np=max(pos_possible)
    else:
        np=min(pos_possible)  # on choisit une case au hasard et on fait bouger le pion
    return(np)



count_p1=0
count_p2=0
nbr=10
for i in range(nbr):
    i=0
    p[0]=(1+n)//2
    p[1]=(2*n**2-n+1)//2
    #print(p,"\n")
    while p[0]<=n**2-n and p[1]>n:  #tant que les pions n'atteignent pas la ligne adverse on les fait bouger
        p[i]=mvt_p(i)
        #print(p)
        i=(i+1)%2  #on change de joueur
    if p[0]>n**2-n:
        print("Le joueur 1 a gagné !\n")
        count_p1=count_p1+1
        #print(count_p1)
    else:
        print("Le joueur 2 a gagné !\n")
        count_p2=count_p2+1
        #print(count_p2)
    
print("\033[31mSur ",nbr , "parties, le joueur 1 à gagné", count_p1, "partie(s) et le joueur 2 à gagné", count_p2, "partie(s)") 
    
